<?php
/* ==================================================================
 	On any edit, update the static data file: "/_source/scripts/data.js" 

	Created: 	2014-10-01	
	Modified:	2014-10-02 - Added grain and styles
				2014-10-09 - Added yeast	
				2014-10-09 - Updated yeast to use query_posts instead of $wpdb->get_results
							 Leaving grain for now, needs to order by meta
                2014-10-10 - Added water
                
 * ================================================================== */
 
// Create static cache to be read from www and other alert destinations 
function agb_update_data( $post_id ) {
    global $post,$wpdb; 
    
    // If post is an autosave/autodraft, return
    if ( wp_is_post_autosave($post_id) || get_post_status($post_id) == 'auto-draft' ) {
        return;
    }
    
    // vars
    $cache_file = get_stylesheet_directory().'/_source/scripts/data.js';
    $datetime = new DateTime;
    date_timezone_set($datetime, timezone_open('America/Los_Angeles'));
    $date = $datetime->format('Y-m-d H:i:s');
    
	ob_start();  //start recording the output
	echo "/* Data last updated: $date due to save/update/delete of post: $post_id */\n";

    /* --------------------------------------
     * Build style data 
     * -------------------------------------- */
      $style_string = 'var agb_styles = [ ';
      $query = "
          SELECT
            posts.*
          FROM
            $wpdb->posts posts
          INNER JOIN
            $wpdb->postmeta meta1 ON posts.ID = meta1.post_ID
          INNER JOIN
            $wpdb->postmeta meta2 ON posts.ID = meta2.post_ID

          WHERE
            posts.post_type = 'agb_styles' AND 
            meta1.meta_key = 'agb_styles_number' AND
            meta2.meta_key = 'agb_styles_letter' AND
            posts.post_status = 'publish' AND
            posts.post_date < NOW() 

          ORDER BY 
            meta1.meta_value ASC,
            meta2.meta_value ASC,
            posts.post_title ASC
      ";

      $posts = $wpdb->get_results($query,OBJECT); 
      if($posts){

      foreach ($posts as $post){ 
         setup_postdata($post);
          $id = $post->ID;
          $category = get_post_meta($id, 'agb_styles_category', true);
          $number = get_post_meta($id, 'agb_styles_number', true);
          $letter = get_post_meta($id, 'agb_styles_letter', true);
          $name = get_the_title();
          $ogmax = get_post_meta($id, 'agb_styles_ogmax', true);
          $ogmin = get_post_meta($id, 'agb_styles_ogmin', true);
          $fgmax = get_post_meta($id, 'agb_styles_fgmax', true);
          $fgmin = get_post_meta($id, 'agb_styles_fgmin', true);
          $abvmax = get_post_meta($id, 'agb_styles_abvmax', true);
          $abvmin = get_post_meta($id, 'agb_styles_abvmin', true);
          $ibumax = get_post_meta($id, 'agb_styles_ibumax', true);
          $ibumin = get_post_meta($id, 'agb_styles_ibumin', true);
          $srmmax = get_post_meta($id, 'agb_styles_colormax', true);
          $srmmin = get_post_meta($id, 'agb_styles_colormin', true); 
          $style_string .= "[\"$category\",\"$number$letter\",\"$name\",$ogmax,$ogmin,$fgmax,$fgmin,$abvmax,$abvmin,$ibumax,$ibumin,$srmmax,$srmmin],";
       }
       }
      // remove last comma (and \n) and print
      echo substr($style_string,0,-1)."];\n";


    /* --------------------------------------
     * Build grain data 
     * -------------------------------------- */
      $grain_string = '';  
      $query = "
          SELECT
            posts.*
          FROM
            $wpdb->posts posts, $wpdb->postmeta postmeta

          WHERE
            posts.post_type = 'agb_grain' AND 
            posts.ID = postmeta.post_id AND
            postmeta.meta_key = 'agb_grain_mash' AND
            posts.post_status = 'publish' 

          ORDER BY 
            postmeta.meta_value DESC, 
            posts.post_title ASC
      "; // AND posts.post_date < NOW() 

      $posts = $wpdb->get_results($query,OBJECT); 
      if($posts){

        foreach ($posts as $post){ 
            setup_postdata($post);

            $id = $post->ID;
            $title = get_the_title();
            $ppg = get_post_meta($id, 'agb_grain_ppg', true);
            $srm = get_post_meta($id, 'agb_grain_srm', true);
            $mash = get_post_meta($id, 'agb_grain_mash', true);
            $mash = ($mash == "true")?1:0; 
            if($title=="Generic"){ // put generic first
                $grain_string = "[$id,\"$title\",$ppg,$srm,$mash],".$grain_string ;
            }
            else{
                $grain_string .= "[$id,\"$title\",$ppg,$srm,$mash],";
            }
        }
      }
      // remove last comma (and \n) and print
      echo "var agb_grain = [ ".substr($grain_string,0,-1)."];\n";


    /* --------------------------------------
     * Build hops data 
     * -------------------------------------- */
      $hop_string = '';
      query_posts(array('post_type'=>'agb_hops','showposts'=>9999,'post_status' => 'publish','orderby'=>'title','order'=>'ASC' )); /* grab all published hops */ 
      while (have_posts()) : the_post(); 
          $id = $post->ID;
          $title = get_the_title();
          $alpha_high = get_post_meta($id, 'agb_hops_alphahigh', true);
          $alpha_low = get_post_meta($id, 'agb_hops_alphalow', true);
          $alpha = ($alpha_high+$alpha_low)/2;
          if($title=="Generic"){ // put generic first
            $hop_string = "[$id,\"$title\",$alpha],".$hop_string;
          }
          else{
            $hop_string .= "[$id,\"$title\",$alpha],"; 
          }
      endwhile;
      // remove last comma (and \n) and print
      echo "var agb_hops = [ ".substr($hop_string,0,-1)."];\n"; 


    /* --------------------------------------
     * Build yeast data 
     * -------------------------------------- */
      $yeast_string = '';
      query_posts(array('post_type'=>'agb_yeast','showposts'=>9999,'post_status' => 'publish','orderby'=>'title','order'=>'ASC' )); /* grab all published hops */ 
      while (have_posts()) : the_post(); 
          $id = $post->ID;
          $title = get_the_title();
          $atthigh = get_post_meta($id, 'agb_yeast_atthigh', true);
          $attlow = get_post_meta($id, 'agb_yeast_attlow', true);
          $attavg = ($atthigh + $attlow)/2;
          $templow = get_post_meta($id, 'agb_yeast_templow', true);
          $temphigh = get_post_meta($id, 'agb_yeast_temphigh', true);
          $tolerance = get_post_meta($id, 'agb_yeast_tolerance', true);
          if($title=="Generic"){ // put generic first
              $yeast_string = "[$id,\"$title\",$attavg,\"$templow - $temphigh\",$tolerance],".$yeast_string; 
          }
          else{
              $yeast_string .= "[$id,\"$title\",$attavg,\"$templow - $temphigh\",$tolerance],"; 
          }
      endwhile;
      // remove last comma (and \n) and print
      echo "var agb_yeast = [ ".substr($yeast_string,0,-1)."];\n"; 

    /* --------------------------------------
     * Build water data 
     * -------------------------------------- */
      $water_string = '';
      query_posts(array('post_type'=>'agb_water','showposts'=>9999,'post_status' => 'publish','orderby'=>'title','order'=>'ASC' )); /* grab all published hops */ 
      while (have_posts()) : the_post(); 
          $id      = $post->ID;
          $title   = get_the_title();
          $ca      = get_post_meta($id, 'agb_water_ca', true);
          $mg      = get_post_meta($id, 'agb_water_mg', true);
          $hco3    = get_post_meta($id, 'agb_water_hco3', true);
          $so4     = get_post_meta($id, 'agb_water_so4', true);
          $na      = get_post_meta($id, 'agb_water_na', true);
          $cl      = get_post_meta($id, 'agb_water_cl', true);

          $temp_string = "[$id,\"$title\",$ca,$mg,$hco3,$so4,$na,$cl],";
          if($title=="Custom"){    // put generic first
              $water_string = $temp_string.$water_string; 
          }
          else{
              $water_string .= $temp_string; 
          }
      endwhile;
      // remove last comma (and \n) and print
      echo "var agb_water = [ ".substr($water_string,0,-1)."];\n";
    
			 
	// stop recording
	 $data = ob_get_contents();
	 ob_end_clean();
	
	// write
	file_put_contents($cache_file, $data);
}
add_action( 'save_post_agb_grain', 'agb_update_data' );
add_action( 'save_post_agb_hops', 'agb_update_data' );
add_action( 'save_post_agb_yeast', 'agb_update_data' );
add_action( 'save_post_agb_water', 'agb_update_data' );
// add_action( 'save_post', 'agb_update_data' ); /* all post types */
?>